;
;  	FERNANDO 3 TI-92 ASM Version Alpha 2.51
;
; 		  (C) 1998 HD Developement
;

 include "macros.h"
 include "kernel.h"
 include "tios.h"
 include "flib.h"
 include "gray4lib.h"
 include "fer3lib.h"
 include "pk92lib.h"

 xdef _main
 xdef _comment

_main:
;**********************************************
;
;		Introduction
;
;**********************************************

 SetFont #2
 lea TitleDialog(PC),a6
 jsr flib::show_dialog
WaitForAKey:
 pause
 cmp #264,d0  ; ESC
 bne NoEsc
 rts
NoEsc:
 cmp #268,d0  ; F1 -> NewGame
 beq NewGame 
 cmp #269,d0  ; F2 -> Option
 bne WaitForAKey
Option:
 lea     OptDialog(PC),a6
 jsr     flib::show_dialog
 move.w  MaxSprite,d0
 lea     strend(PC),a0
 moveq   #2,d1
 bsr     ConvSTR
 move.w  #4,-(a7)
 move.l  a0,-(a7)
 move.w  #103,-(a7)
 move.w  #192,-(a7)
 jsr  	 tios::DrawStrXY
 lea     10(a7),a7
 move.w  Speed,d0
 lea     strend(PC),a0
 moveq   #2,d1
 bsr     ConvSTR
 move.w  #4,-(a7)
 move.l  a0,-(a7)
 move.w  #118,-(a7)
 move.w  #192,-(a7)
 jsr  	 tios::DrawStrXY
 lea     10(a7),a7
WaitForAKey2:
 pause
 cmp #264,d0  ; ESC
 beq _main
 cmp #268,d0
 bne NoF1
 move.w #10,Diff
 move.w #300,Diff2
 bra Option
NoF1:
 cmp #269,d0
 bne NoF2
 move.w #50,Diff
 move.w #100,Diff2

 bra Option
NoF2:
 cmp #270,d0
 bne NoF3
 move.w #200,Diff
 move.w #10,Diff2
 bra Option
NoF3:
 cmp #272,d0
 bne NoF5
 move.w #1,vith
 move.w #40,Hauteur
 bra Option
NoF5:
 cmp #273,d0
 bne NoF6
 move.w #2,vith
 move.w #20,Hauteur
 bra Option
NoF6:
 cmp #274,d0
 bne NoF7
 move.w #4,vith
 move.w #10,Hauteur
 bra Option
NoF7:
 cmp #338,d0
 bne NoUp
 move.w MaxSprite,d0
 beq WaitForAKey2
 subq  #1,d0
 move.w d0,MaxSprite
 bra Option
NoUp:
 cmp #344,d0
 bne NoDown
 move.w MaxSprite,d0
 cmp.w #30,d0
 beq WaitForAKey2
 addq  #1,d0
 move.w d0,MaxSprite
 bra Option
NoDown:
 cmp #337,d0
 bne NoLef
 move.w Speed,d0
 beq WaitForAKey2
 subq #1,d0
 move.w d0,Speed
 bra Option
NoLef:
 cmp #340,d0
 bne NoRi
 move.w Speed,d0
 cmp.w #99,d0
 beq WaitForAKey2
 addq #1,d0
 move.w d0,Speed
 bra Option
NoRi:
 cmp #275,d0
 bne WaitForAKey2
 lea inputdialog(PC),a6
 jsr flib::show_dialog
 move.w  #60,d3 ;x
 move.w  #66,d1 ;y
 clr.w   tios::kb_vars+$1C
 lea     Name(PC),a0
 clr.l	 d4
Input:
 jsr     flib::idle_loop
 cmp.w	 #13,d0
 beq     InputDone
 cmp.w	 #257,d0
 beq     BackSpace
 cmp.w   #32,d0
 bcs     Input
 cmp.w   #256,d0
 bcc     Input
 cmp.w   #8,d4
 beq     Input
 move.b  d0,(a0)+
 move.w  d0,d2
 move.w  d3,d0
 bsr     WriteChar
 addq	 #8,d3
 addq	 #1,d4
 bra Input
BackSpace:
 tst.w   d4
 beq     Input
 clr.b   -(a0)
 subq    #8,d3
 move.w  d3,d0
 moveq   #32,d2
 bsr     WriteChar
 subq    #1,d4
 bra     Input
InputDone:
 clr.b	 (a0)
 bra     Option

;**********************************************
;
; 	Verification de la memoire disponible
;
;**********************************************
NewGame:

 move.w #3,Vi 
 clr.w  SubLevel

 clr.l   d0
 move.w  MaxSprite,d0
 mulu.w  #148,d0		   ; The sprites
 add.l   #132,d0		   ; And Fernand's back
 add.l   #7680,d0 		   ; And (MaxXn+1)*(MaxYn+1)*15*8*2
 add.l   #4150,d0		   ; And GrayScale !
 move.l  d0,-(a7)
 jsr     tios::HeapAlloc           ; Call the romlib function
 add.l   #$04,a7                   ; Restore the stack pointer
 cmp.l   #0,d0
 beq 	 _main		           ; Not enougth memory
 move.w  d0,-(a7)
 jsr     tios::HeapFree		   ; Destroy the Handle
 lea     2(a7),a7
 
; *********************************************
;
;  		INITIALISATION
;
; **********************************************

; Redirige Int #1
 move.w #$0700,d0
 trap   #1	; Set all int off
 move.L $64,oldint#1	; Save Old Int #1
 bclr.b #2,$600001	; We can write in low memory !
 move.l #newint#1,$64	; New Int
 bset.b #2,$600001	; Restore the low memory Int
 trap   #1	; Restore all int 

 jsr	flib::zap_screen

; Synchro betwen the screen and vbl_phase
; Yes it is very badly coded

wait:
 bsr GetKeyStat
\f5:
 cmp.w #0,vbl_phase
 bne   \f5
 btst.b #4,keystat+1
 beq \Fini
 WriteStr #0,#0,#4,f5
\f6:
 cmp.w #1,vbl_phase
 bne   \f6
 btst.b #4,keystat+7
 beq \Fini
 WriteStr #0,#0,#4,f6
\f7:
 cmp.w #2,vbl_phase
 bne   \f7
 btst.b #4,keystat+5
 beq \Fini
 WriteStr #0,#0,#4,f7
\f8:
 cmp.w #3,vbl_phase
 bne   \f8
 btst.b #4,keystat+3
 beq \Fini
 WriteStr #0,#0,#4,f8
 bra wait
\Fini:
 clr.w vbl_phase

; Appel  GrayLib pour passer en 4 couleurs
 jsr gray4lib::on
 move.l gray4lib::plane0,a0
 move.l a0,greyplane 

; Rservation de la mmoire pour les sprites
 clr.l   d0
 move.w  MaxSprite,d0
 mulu.w  #148,d0		   ; The sprites
 add.W   #132,d0		   ; Fernand's back
 move.l  d0,-(a7)
 jsr     tios::HeapAlloc           ; Call the romlib function
 add.l   #$04,a7                   ; Restore the stack pointer
 move.w  d0,sprite_handle
 tios::DEREF	 d0,a0
 move.l  a0,sprite_adr

 clr.l d0   
 move.w MaxSprite,d0
 lsl.w #4,d0
 move.l sprite_adr,a0
 add.l d0,a0
 move.l a0,sprite_back_store


;***********************************************
;
; 		Dbut du niveau !
;
;***********************************************

StartLevel:
; On copie le niveau ailleurs : Plus tard, decompactage
 move.w SubLevel,d0
 jsr    fer3lib::Go_Level
 clr.w  xn

; Searching 'Name' in folder 'main'
 pea MainFolder(PC)
 move.w FOLDER_LIST_HANDLE,-(sp)
 jsr tios::FindSymEntry
 lea 6(sp),sp
 cmp.l #0,a0
 beq exit
 move.w tios::SYM_ENTRY.hVal(a0),d0	; Get the handle of main
 pea Name(PC)
 move.w d0,-(sp)
 jsr tios::FindSymEntry
 lea 6(sp),sp
 cmp.l #0,a0
 beq exit
 move.w tios::SYM_ENTRY.hVal(a0),-(sp)	; Push the handle of the prog
 jsr kernel::exec
 lea 2(sp),sp
 tst.l d0
 bne exit
 
; Get datas
 jsr fer3lib::Get_Adresse
 cmp.l #0,d1
 bne   exit
 move.l d0,xnd
 move.l a0,level_adr

 clr.w  Cf
 clr.w  Bj
 clr.w  v

; Dlimiter dpart
 clr.l	 xj
 clr.l   xn
 clr.L   d0
 move.b  xnd,d0
 move.w  d0,xn
 move.b  ynd,d0
 move.w  d0,yn
 move.b  xd,d0
 lsl.l   #4,d0
 move.w  d0,xj
 move.b  yd,d0
 lsl.l   #4,d0
 move.w  d0,yj

; Init
 clr.w action ; DEBOUT
 lea    Tombe(PC),a6
 move.l a6,ADR_action

; Initialisation pour le statut
 SetFont #0

; Dbut du sous-niveau 
LevelLoop:
 bsr   GetLevelADR
 clr.w NbrSprite
 bsr   PutDecor   


; Inialisation indispensable
 clr.l d0
 clr.l d1
 clr.w EffacerDecor
 bsr Statut
 
 clr.w timer

; Del a bug
 lea Marche(PC),a0
 cmp.l ADR_action,a0
 bne main_loop
 lea    Tombe(PC),a6
 move.l a6,ADR_action
 
main_loop:

; Affichage du personnage
 clr.l d2
 move.w xj,d0
 move.w yj,d1
 move.w action,d2
 move.w v,d3
 beq    AffSuite
 move.w #32,d2
 subq  #1,d3
 move.W d3,v
AffSuite:
 add.w  sens,d2
 lea    fernand(PC),a0
 move.l sprite_back_store,a3
 bsr PutFer

; Pour tous les sprites affichage
 move.w NbrSprite,d3
 move.w d3,ExNbrSprite
 beq	PasDeSprite
 subq  #1,d3
 lea 	Sprite(PC),a0
 move.l sprite_adr,a1
SpriteAffLoop:
 move.w 6(a1),d0
 move.w 8(a1),d1
 move.b 10(a1),d2
 bsr    PutFer
 lea    16(a1),a1
 dbra   d3,SpriteAffLoop
PasDeSprite:
 move.l a3,SpriteAdrTemp

 move.w xj,d0
 move.w yj,d1

 bsr GetKeyStat
 btst.b #0,keystat		; 2ND ?
 beq exit

 move.l ADR_action,a6

; Left ?
 btst.b #4,keystat
 bne    NoLeft

 move.w #1,sens
 sub.w  vith,d0
 bsr GetTest
 cmp.b #1,d2
 beq SuiteAct
 move.w d0,xj
 bra SuiteAct

; Right ?
NoLeft: 
 btst.b #6,keystat
 bne    SuiteAct

 clr.w sens
 add.w  vith,d0
 bsr GetTest
 cmp.b #1,d2
 beq SuiteAct
 move.w d0,xj

SuiteAct:

; test sortie de l'ecran  Gauche et  droite
 cmp.b  #224,d0
 bls    Suitegd
SortiegdEntree:
 move.w xn,d3
 move.l level,a4
 move.l leveltest,a5
 move.w d3,d7
 cmp.b  #240,d0
 bhi    SortieGauche
;SortieDroite
 cmp.w  #7,d3	; MaxXn
 beq 	SortieXDB
 addq   #1,d3
 move.w d3,xn
 bsr    GetLevelADR
 clr.w  d0
 move.w d0,xj
 move.w yj,d1
 bsr GetTest
 cmp.b  #1,d2
 bne    LevelLoop
 move.l a4,level
 move.l a5,leveltest
 move.w d7,xn
SortieXDB:
 move.w #224,d0
 move.w d0,xj
 clr.w  Mx
 bra Suitegd
SortieGauche: 
 move.w xn,d0
 beq    SortieXGB
 subq  #1,d0
 move.w d0,xn
 bsr    GetLevelADR
 move.w #224,d0
 move.w d0,xj
 move.w yj,d1
 bsr    GetTest
 cmp.b  #1,d2
 bne    LevelLoop
 move.l a4,level
 move.l a5,leveltest
 move.w d7,xn
SortieXGB:
 clr.w  xj
 clr.w  Mx
Suitegd:

; Jump to the action of Fer
 jmp (a6)
FinSR:

; Test sortie Haut/Bas
 move.w yj,d1
 cmp.b  #111,d1
 bls 	Suitehb
 move.l a6,ADR_action
 clr.l  d3
 move.w yn,d3
 move.l level,a4 	    ; Save Data
 move.l leveltest,a5
 move.w d3,d7
 cmp.b  #200,d1
 bhi    SortieHaut
;SortieBas
 cmp.w  #3,d3 		  ;MaxYn
 beq    SortieYBB
 addq   #1,d3
 move.w d3,yn
 bsr    GetLevelADR
 clr.w  d1
 move.W d1,yj
 move.w xj,d0
 bsr    GetTest
 cmp.b  #1,d2
 bne    LevelLoop
 move.l a4,level
 move.l a5,leveltest
 move.w d7,yn
 move.w #112,d1
 move.W d1,yj
 lea    Marche(PC),a6
 bra    Suitehb
SortieYBB:
 bra    Sortie
SortieHaut:
 cmp.b  #0,d3
 beq    SortieYHB
 sub.w  #1,d3
 move.w d3,yn
 bsr    GetLevelADR
 move.w #112,d1
 move.W d1,yj
 move.w xj,d0
 bsr GetTest
 cmp.b #1,d2
 bne LevelLoop
 move.l a4,level
 move.l a5,leveltest
 move.w d7,yn
SortieYHB:
 clr.w My
 clr.w yj
Suitehb:

; Lecture des options
 move.w xj,d3
 move.w yj,d4
 lea    Test(PC),a2
 bsr    Lecture
 lsl.l  #2,d2
 move.l 0(a2,d2),a0
 lea    Teste(PC),a5
 jmp 	(a0)
Teste:
 add.w  #15,d4
 bsr    Lecture
 lsl.l  #2,d2
 move.l 0(a2,d2),a0
 lea    Teste2(PC),a5
 jmp 	(a0)
Teste2:
 add.w  #15,d3
 bsr    Lecture
 lsl.l  #2,d2
 move.l 0(a2,d2),a0
 lea    Teste3(PC),a5
 jmp    (a0)
Teste3:
 sub.w  #15,d4
 bsr    Lecture
 lsl.l  #2,d2
 move.l 0(a2,d2),a0
 lea    Teste4(PC),a5
 jmp 	(a0)
Teste4:

; Pour tous les sprites, gestion
 move.w NbrSprite,d3
 beq	PasDeSpriteGest
 subq   #1,d3
 move.l sprite_adr,a0
 lea    SpriteADR,a2
SpriteGestLoop:
 clr.l  d0
 move.b (a0),d0
 lsl.l  #2,d0
 move.l 0(a2,d0),a1
 jmp    (a1)
Retour:
 adda.l #16,a0
RetourSansInc:
 dbra   d3,SpriteGestLoop
PasDeSpriteGest:

; save action, why ?
 move.l a6,ADR_action

; Attente ...
\delay:
 tst.w timer
 bne   \delay

; Rafraichissement de l'cran ...
\refresh
 tst.w vbl_phase
 bne   \refresh

; Prparation pour le prochain dlai
 move.w Speed,d3
 move.W d3,timer

; Pour tous les sprites, effacement
 move.w ExNbrSprite,d3
 move.l SpriteAdrTemp,a0
SpriteAffDelLoop:
 sub.l  #132,a0
 bsr    RemoveSprite
 dbra   d3,SpriteAffDelLoop

; On efface le dcor s'il le faut,
 move.w EffacerDecor,d3
 beq    SuiteDecorEffacer
 subq   #1,d3
 lea    EffacerADR(PC),a0
 clr.l  d0
 clr.l  d1
 clr.l  d2
DecorEffacerLoop:
 move.w (a0)+,d0
 move.w (a0)+,d1
 bsr    PutSprite
 dbra   d3,DecorEffacerLoop
 move.w d2,EffacerDecor
SuiteDecorEffacer:

 bra   main_loop

exit:
 move.w #1,Vi

Sortie:

 jsr fer3lib::Destroy_Level

 cmp.w #255,xn
 beq   LevelCompleted

 move.w Vi,d0
 subq   #1,d0
 beq    Exit
 move.w d0,Vi
 jmp    StartLevel
LevelCompleted:
 add.w  #1,SubLevel
 jmp    StartLevel

Exit:
; Dtruire la rserve de sprite

 move.w  sprite_handle,d0
 move.w  d0,-(a7)
 jsr     tios::HeapFree
 lea     2(a7),a7

; Eteindre les 4 couleurs
 jsr gray4lib::off

; Restore int #1
 move.w #$0700,d0
 trap #1
 bclr.b #2,$600001
 move.l oldint#1(PC),$64
 bset.b #2,$600001
 trap #1

 jmp _main		; Retour  l'intro
;*****************************************************
;
; 		Les diffrentes actions du personnage
;
;*****************************************************

; DATA
action:		dc.w 0
sens:		dc.w 0
a:		dc.w 0
v:		dc.w 0
ADR_action   	dc.l 0
St:		dc.w 0
b1:		dc.w 0
Mx:		dc.w 0
My:		dc.w 0

; JUMP
Saut:
 move.w St,d3
 beq   Sau2
 and.w #7,d3
 bne   Sau1
 btst.b #3,keystat
 beq   Sau1
 move.w #1,St
Sau1:
 sub.w #1,St
 move.w #18,action  ;SAUT
 move.w xj,d0
 move.w yj,d1
 sub.w  vith,d1
 cmp.w #112,d1
 bhi Sau3
 bsr GetTest
 cmp.b #1,d2
 beq  FinSR
Sau3:
 move.w d1,yj
 bra  FinSR
Sau2:
 lea  Tombe(PC),a6

; FALL & WALK
Tombe:
 move.w xj,d0
 move.w yj,d1
 add.w  vith,d1
 bsr GetTest
 cmp.b #1,d2
 beq Marche
 move.w d1,yj
 move.w #20,action ; TOMBE
 bra FinSR

Marche:
 btst.b #3,keystat
 bne  Mar1
 move.w Hauteur,d0
 move.W d0,St ; HAUTEUR_SAUT
 Lea  Saut(PC),a6
 bra  Sau1

Mar1:
 cmp.b #255,keystat
 bne   Mar2
 and.w #255,b1
 beq   PasseTemps
 add.w #1,b1
 clr.w action ; DEBOUT
 bra FinSR

Mar2:
 move.w #1,b1
 move.w #2,action ; MARCHE
 move.w a,d0      ; Gre les diffrentes animations
 addq   #1,d0
 and.w  #31,d0    ; Modulo 32
 move.w d0,a
 and.w  #24,d0	  ; La meme animation toutes les 8 images
 lsr.w  #2,d0     ; a est un rel  virgule fixe
 add.w  d0,action
 bra FinSR

; MOVE ON BABY !!!
PasseTemps:
 clr.w b1
 move.w #22,action
 move.w a,d0       ; Gre les diffrentes animations
 addq  #1,d0
 and.w  #31,d0
 move.w d0,a
 and.w  #24,d0
 lsr.w  #2,d0
 add.w  d0,action
 bra FinSR
 
; BIG JUMP WITH A BUMPER
Bumper:
 move.w St,d3
 beq    Bump2
 subq   #1,d3
 move.w d3,St

 move.w #10,action  ;Bumper
 move.w a,d0
 addq   #1,d0
 and.w  #31,d0
 move.w d0,a
 and.w  #24,d0
 lsr.w  #2,d0
 add.w  d0,action

 move.w xj,d0
 move.w yj,d1
 sub.w  vith,d1
 cmp.w #112,d1
 bhi Bump3
 bsr GetTest
 cmp.b #1,d2
 beq  FinSR
Bump3:
 move.w d1,yj
 bra  FinSR
Bump2:
 lea  Tombe(PC),a6
 bra  Tombe

; Virtual Race
Propulseur:
 move.w Mx,d0
 bne PropSuite
 move.w My,d0
 beq ThatsAll
PropSuite:
 move.w xj,d0
 move.w yj,d1
 clr.w  sens
 add.w  Mx,d0
 cmp.b #224,d0
 bhi  SortiegdEntree
 bsr GetTest
 cmp.b #1,d2
 beq ThatsAll
 move.w d0,xj
 add.w  My,d1
 bsr GetTest
 cmp.b #1,d2
 beq ThatsAll
 move.w d1,yj
 bra    FinSR
ThatsAll:
 clr.w  Mx
 clr.w  My
 lea    Tombe(PC),a6
 bra 	Tombe
 
; ****************************************************
;
;		Tests : Fer a touch en d3,d4
;
; ****************************************************

; Tableau d'indirection
Test	dc.l Rien	; 0
	dc.l Rien	; 1
	dc.l PlateForme ; 2
	dc.l Monte	; 3
	dc.l Bijou	; 4
	dc.l OneUp	; 5
	dc.l BumperG	; 6
	dc.l Clef	; 7
	dc.l Porte	; 8
	dc.l Pic	; 9
	dc.l Haut	; 10
	dc.l Bas	; 11
	dc.l Gauche	; 12
	dc.l Droite	; 13
	dc.l Arrive	; 14
	dc.l Rien 	; 15 -> Ennemi type 1
	dc.l Rien	; 16 -> Ennemi type 2
	dc.l Rien	; 17 -> Ennemi type 2

SpriteADR
	dc.l SpriteHor  ; 0
	dc.l SpriteVert ; 1
	dc.l SpriteRien ; 2

; L'adresse de retour (~  une SR) est dans a5

Rien:	jmp (a5)
 
PlateForme:
	movem.l d3-d4,-(a7)
   	and.w   #$FFF0,d4
	sub.w   #16,d4
	move.l  d4,d3
	move.w	yj,d4
	eor.w	d3,d4
	and.w   #$FFFC,d4
	bne 	PlateFormeSuite
 	move.w 	d3,yj
PFEntry:
	btst.b #3,keystat
	bne  PFMar1
	move.w Hauteur,d3
	move.w d3,St ; HAUTEUR_SAUT
	Lea  Saut(PC),a6
	bra  PlateFormeSuite
PFMar1:
	cmp.b #255,keystat
	bne PFMar2
	clr.w action ; DEBOUT
	bra PlateFormeSuite
PFMar2:
	move.w #2,action ; MARCHE
	move.w a,d0      ; Gre les diffrentes animations
	addq   #1,d0
	and.w  #31,d0    ; Modulo 32
	move.w d0,a
	and.w  #24,d0	  ; La meme animation toutes les 8 images
	lsr.w  #2,d0
	add.w  d0,action
PlateFormeSuite:
	movem.l (a7)+,d3-d4
	jmp (a5)

Monte:
	movem.l d3-d4,-(a7)
   	and.w   #$FFF0,d4
	sub.w   #16,d4
	move.w  d4,yj
	bra PFEntry
	
Bijou:
	movem.l d0-d2/a0,-(a7)
	add.w	#1,Bj
BijouClear:
	move.w  d3,d0
	move.w  d4,d1
	and.w 	#$FFF0,d0
	and.w	#$FFF0,d1
	clr.l   d2
	bsr 	Ecriture
	lea     EffacerADR(PC),a0
	move.w  EffacerDecor,d2
	add.w   #1,EffacerDecor
	lsl.l   #2,d2
	adda.l  d2,a0
 	move.w  d0,(a0)+
	move.w  d1,(a0)+
	bsr Statut
	movem.l (a7)+,d0-d2/a0
	jmp (a5)

OneUp:
	movem.l d0-d2/a0,-(a7)
	add.w 	#1,Vi
	bra BijouClear
Clef:
	movem.l d0-d2/a0,-(a7)
	add.w	#1,Cf
	bra BijouClear
Porte:
 	movem.l d0-d2/a0,-(a7)
	move.w  Cf,d0
 	beq 	NoPass
	subq    #1,d0
	MOVE.w  d0,Cf
	bra	BijouClear
NoPass: 
	move.w xj,d0
	move.w yj,d1
	btst.b #4,keystat
	bne    NoLeftNP
	add.w  vith,d0
	move.w d0,xj
	bra SuiteActNP
NoLeftNP:
	btst.b #6,keystat
	bne    SuiteActNP1
	sub.w  vith,d0
	move.w d0,xj
	bra SuiteActNP
SuiteActNP1:
	sub.w  vith,d1
	move.w d1,yj
SuiteActNP:
	movem.l (a7)+,d0-d2/a0
	jmp (a5)

BumperG:
	move.l d4,-(a7)
	and.w #$000F,d4
	eor.w #$000F,d4
	bne    BumperGOK
	lea    Bumper(PC),a6 ; Adresse action
	move.W Hauteur,d3
	lsl.w  #1,d3
	move.w d3,St	     ; Puissance Bumper
BumperGOK:
	move.l (a7)+,d4
	jmp  (a5)

Pic:
	movem.l d3-d4,-(a7)
	and.w #$000F,d4
	eor.w #$000F,d4
	bne    PicRien
	bsr	Touche
PicRien:
	movem.l (a7)+,d3-d4
  	jmp  (a5)

Touche:
	clr.w  d4
	move.w v,d3
	bne    PicSort
	move.w Bj,d3
	beq    PicMort
	cmp.w  Diff,d3
	bhi    PicDecremente
	clr.w  d3
	bra    PicFin
PicDecremente:
	sub.w  Diff,d3
 	bra    PicFin
PicMort:
	clr.w  d3
	lea    Sortie(PC),a5
	move.w #1,d4
PicFin:
	move.w d3,Bj
	move.w Diff2,d3
	move.W d3,v     ; Dure
	bsr    Statut
	bsr    FlashScreen
PicSort:
	rts

Haut:	
	movem.l d0-d1,-(a7)
	lea    Propulseur(PC),a6
	move.w vith,d0
	lsl.w  #1,d0
	clr.w  d1
	sub.w  d0,d1
	move.w d1,My
	move.w #36,d0
	move.w d0,action
	movem.l (a7)+,d0-d1
	jmp    (a5)
Bas:	
	move.l d0,-(a7)
	lea    Propulseur(PC),a6
	move.w vith,d0
	lsl.w  #1,d0
	move.w d0,My
	move.w #37,d0
	move.w d0,action
	move.l (a7)+,d0
	jmp    (a5)

Gauche:
	movem.l d0-d1,-(a7)
	lea    Propulseur(PC),a6
	move.w vith,d0
	lsl.w  #1,d0
	clr.w  d1
	sub.w  d0,d1
	move.w d1,Mx
	move.w #35,action
	movem.l (a7)+,d0-d1
	jmp    (a5)

Droite:
	move.l d0,-(a7)
	lea    Propulseur(PC),a6
	move.w vith,d0
	lsl.w  #1,d0
	move.w d0,Mx
	move.w #34,action
	move.l (a7)+,d0
	jmp    (a5)
	
Arrive:
	move.w #255,xn
	jmp Sortie

SpriteHor:
	movem.l d0-d4/a0-a2,-(a7)
	move.w  6(a0),d0
	move.w  8(a0),d1
	clr.l   d3
	move.b  11(a0),d3
	beq	SpDroi
	addq   #1,d0
	bra     SpSuite
SpDroi:	subq    #1,d0
SpSuite:
	cmp.b   #224,d0
	bhi	SpChg

SpUni:
	bsr	GetTest
	cmp.b	#1,d2
	beq 	SpChg
	move.w  d0,6(a0)
	move.W  d1,8(a0)
	bra SpSui2
SpChg:	eor.b   #1,d3
	move.b  d3,11(a0)
SpSui2:	
	move.w xj,d2
	sub.w  #15,d2
	cmp.w  d2,d0
	blt    NoTuch
	add.w  #30,d2
	cmp.w  d2,d0
	bgt    NoTuch

	move.w yj,d2
	sub.w  #15,d2
	cmp.w  d2,d1
	blt    NoTuch
	add.w  #30,d2
	cmp.w  d2,d1
	bgt    NoTuch

	cmp.W yj,d1
	bhi	FerTuch
	move.l a0,-(a7)
	bsr    Touche
	move.l (a7)+,a0
	cmp.w #1,d4
	beq Mort
	bra NoTuch

FerTuch:
	move.W 14(a0),d0
	bne    NoTuchBefore

	sub.w #1,NbrSprite
	move.w 2(a0),d3
	move.w 4(a0),d4
	clr.l  d2
	bsr	Ecriture
	move.l a0,a2		; Source
	lea    16(a0),a1	; Destination
	move.l sprite_back_store,d0
	sub.l  a0,d0
	sub.l  #16,d0		; How many ?
	lsr.l  #2,d0	; LongWords = 4 * Bytes
\DelBoucle:
	move.l (a1)+,(a2)+
	dbra   d0,\DelBoucle
	movem.l (a7)+,d0-d4/a0-a2
	bra RetourSansInc

NoTuchBefore:
	sub.w  #50,d0
	move.W d0,14(a0)
	move.w Hauteur,d0
	move.W d0,St ; HAUTEUR_SAUT
	Lea  Saut(PC),a6
NoTuch:
	move.w 12(a0),d0  ; Gre les diffrentes animations
	addq   #1,d0
	and.w  #31,d0     ; Modulo 32
	move.w d0,12(a0)
	and.w  #24,d0	  ; La meme animation toutes les 8 images
	lsr.w  #2,d0
	add.b  11(a0),d0
	add.b  1(a0),d0
	move.b d0,10(a0)
	movem.l (a7)+,d0-d4/a0-a2
	bra	Retour

Mort:	movem.l (a7)+,d0-d4/a0-a2
	bra	Sortie

SpriteVert:
	movem.l d0-d4/a0-a2,-(a7)
	move.w  6(a0),d0
	move.w  8(a0),d1
	clr.l   d3
	move.b  11(a0),d3
	beq	SpDown
	addq    #1,d1
	bra     SpSuitV
SpDown:	subq   #1,d1
SpSuitV:
	cmp.b   #112,d1
	bhi	SpChg
	bra 	SpUni

SpriteRien:
	movem.l d0-d4/a0-a2,-(a7)
	move.w  6(a0),d0
	move.w  8(a0),d1
	clr.l   d3
	move.b  11(a0),d3
	bra 	SpUni

; ****************************************************
;
;                Routines
;
; *****************************************************

; Puts Action D2 of a0 at D0,D1, saving BackStore in a3
PutFer:
 movem.l d0-d4/a0-a2,-(a7)
 lsl.l   #6,d2
 adda.l  d2,a0
 lsl.w   #1,d1
 move.l  d1,d2
 lsl.w   #4,d2
 sub.w   d1,d2
 move.b  d0,d1
 and.w   #$FFF0,d0
 lsr.b   #3,d0
 add.w   d0,d2
 and.b   #$0F,d1
 sub.b   #16,d1
 neg     d1
 moveq   #15,d0
 lea     LCD_MEM,a1
 move.l  greyplane,a2
 adda.l  d2,a1
 adda.l  d2,a2
 move.l  d2,(a3)+
 move.l  #$FFFF0000,d3
 rol.l   d1,d3

PF_PutRow:
 clr.l   d2
 move.w  (a0)+,d2
 lsl.l   d1,d2
 move.l  (a1),D4
 move.l  D4,(a3)+
 or.l    d2,(a1)
 clr.l   d2
 move.w  (a0)+,d2
 lsl.l   d1,d2
 move.l  (a2),d4
 move.l  d4,(a3)+ 
 or.l    d2,(a2) 	
 lea     30(a1),a1
 lea     30(a2),a2
 dbra    d0,PF_PutRow
 movem.l (a7)+,d0-d4/a0-a2
 rts

; Remove the sprite using a0
RemoveSprite:
 movem.l d1/a0-a2,-(a7)
 move.l (a0)+,d1
 lea     LCD_MEM,a1
 move.l  greyplane,a2
 adda.l  d1,a1
 adda.l  d1,a2
 move.w #15,d1
RemoveLoop:
 move.l (a0)+,(a1)
 move.l (a0)+,(a2)
 lea 30(a1),a1
 lea 30(a2),a2
 dbra d1,RemoveLoop
 movem.l (a7)+,d1/a0-a2
 rts

; Puts sprite D2 of Decor at D0,D1
PutSprite:
 movem.l d0-d3/a0-a2,-(a7)
 lea     decor(PC),a0
 lsl.l   #6,d2
 adda.l  d2,a0
 lsl.w   #1,d1
 move.l  d1,d2
 lsl.w   #4,d2
 sub.w   d1,d2
 move.b  d0,d1
 and.w   #$FFF0,d0
 lsr.b   #3,d0
 add.w   d0,d2
 and.b   #$0F,d1
 sub.b   #16,d1
 neg     d1
 moveq   #15,d0
 lea     LCD_MEM,a1
 move.l  greyplane,a2
 adda.l  d2,a1
 adda.l  d2,a2
 move.l  #$FFFF0000,d3
 rol.l   d1,d3
PS_PutRow:
 clr.l   d2
 move.w  (a0)+,d2
 lsl.l   d1,d2
 and.l   d3,(a1)
 or.l    d2,(a1)
 clr.l   d2
 move.w  (a0)+,d2
 lsl.l   d1,d2
 and.l   d3,(a2)
 or.l    d2,(a2)
 lea     30(a1),a1
 lea     30(a2),a2
 dbra    d0,PS_PutRow
 movem.l (a7)+,d0-d3/a0-a2
 rts

; Print the screen
PutDecor:
 movem.l d0-d6/a0-a5,-(a7)
 clr.l  d2
 move.l level,a3
 move.l leveltest,a5
 move.l sprite_adr,a4
 move.l	#7,d4
 clr.l  d1
LoopDecor1:
 clr.l	d0
 move.l   #14,d3 
LoopDecor:
 move.b (a3)+,d2 
 move.b (a5)+,d5
 cmp.b  #14,d5		; SpriteTab
 bhi    NewSprite
SpriteSuite:
 bsr PutSprite
 add.l  #16,d0
 dbra d3,LoopDecor
 add.l  #16,d1
 dbra d4,LoopDecor1

 move.l  #44,d0
 move.l  greyplane,a0   ; Make A0 point at the greyscale plane (plane 1)
 lea     LCD_MEM,a1     ; and A1 to the LCD memory (plane 0)
 add.l   #3660,a0
 add.l   #3660,a1
RepClr:
 clr.l   (a0)+           ; Clear a longword, increase A0 with 4
 clr.l   (a1)+           ; Clear a longword, increase A1 with 4
 dbra    d0,RepClr       ; Repeat
 movem.l (a7)+,d0-d6/a0-a5
 rts

; A sprite is somewhere : we have to save it .
NewSprite:
 move.w NbrSprite,d6
 cmp.w  MaxSprite,d6
 beq    SpriteForget
 addq   #1,d6
 move.w d6,NbrSprite
 sub.b  #15,d5		; SpriteTab  partir de ___ ce sont des sprites
 move.b d5,(a4)+
 move.b d2,(a4)+
 move.w d0,(a4)+
 move.w d1,(a4)+
 move.w d0,(a4)+
 move.w d1,(a4)+
 move.b d2,(a4)+
 clr.b  (a4)+
 clr.w  (a4)+
 move.w #1000,(a4)+
SpriteForget:
 clr.l  d2
 bra SpriteSuite
 
; Get the key ...
GetKeyStat:
 movem.l d0-d1/a0,-(a7)
 lea keystat(PC),a0
 move.w #$FFFE,d0
 moveq  #9,d1
GetKeys:
 move.w d0,$600018
 nop
 nop
 nop
 nop
 nop
 nop
 move.b $60001B,(a0)+
 rol.w  #1,d0
 dbra   d1,GetKeys
 movem.l (a7)+,d0-d1/a0
 rts

GetTest:	; Teste si le perso en D0,D1 est sur un bloc
		; Retourne D2 = 1 (Pas pos), AUTRE sinon
 movem.l d3-d4,-(a7)

 move.l d0,d3
 move.l d1,d4
 bsr Lecture
 cmp.w #1,d2
 beq TestFaux

 add.l #15,d3
 bsr Lecture
 cmp.w #1,d2
 beq TestFaux

 add.l #15,d4
 bsr Lecture
 cmp.w #1,d2
 beq TestFaux

 sub.l #15,d3
 bsr Lecture
TestFaux:
 movem.l (a7)+,d3-d4
 rts

; Lecture Data du niveau au coordones d3,d4
; Return D2
Lecture:
 movem.l d3-d4/a0,-(a7)
 move.l    leveltest,a0
 lsr.l  #4,d3
 lsr.l  #4,d4
 sub.l  d4,d3
 lsl.l  #4,d4
 add.l  d4,d3
 clr.l  d2
 move.b 0(a0,d3),d2
 movem.l (a7)+,d3-d4/a0
 rts

; Ecriture Data du niveau au coordones d3,d4 
; Source d2.b -> Test  d2.w / 2^8 -> Graph
Ecriture:
 movem.l d3-d4/a0-a1,-(a7)
 move.L    leveltest,a0
 move.l    level,a1
 lsr.l  #4,d3
 lsr.l  #4,d4
 sub.l  d4,d3
 lsl.l  #4,d4
 add.l  d4,d3
 adda.l d3,a0
 adda.l d3,a1
 move.b d2,(a0)
 lsr.l  #8,d2
 move.b d2,(a1)
 movem.l (a7)+,d3-d4/a0-a1
 rts

; Convertion d'un nombre en chaine de caractre
; a0 -> Pointeur vers la chaine en sens inverse
; d0 -> Nombre
; d1 -> Nombre de chiffres
ConvSTR:
 movem.l d0-d2,-(a7)
 clr.b (a0)
Rep1:
 divu   #10,d0
 move.l d0,d2
 swap   d2
 add.b  #48,d2
 move.b d2,-(a0)
 subq   #1,d1
 and.l  #$FFFF,d0
 bne    Rep1
 tst.w  d1
 beq    CSDone
 subq   #1,d1
Rep2:
 move.b #32,-(a0)
 dbra   d1,Rep2
CSDone:
 movem.l (a7)+,d0-d2
 rts

; Affiche le statut du personnage
Statut:
 movem.l d0-d2/a0-a1,-(a7)

 WriteStr #0,#123,#4,statut
 
 move.w  Bj,d0
 cmp.w  #9999,d0
 bhi 	Stat1
 lea strend(PC),a0
 moveq   #4,d1
 bsr ConvSTR
 move.w  #4,-(a7)
 move.l  a0,-(a7)
 move.w  #123,-(a7)
 move.w  #28,-(a7)
 jsr 	tios::DrawStrXY
 lea    10(a7),a7
 
Stat1:
 move.w  Vi,d0
 cmp.w  #99,d0
 bhi 	Stat2
 lea strend(PC),a0
 moveq   #2,d1
 bsr ConvSTR
 move.w  #4,-(a7)
 move.l  a0,-(a7)
 move.w  #123,-(a7)
 move.w  #64,-(a7)
 jsr 	tios::DrawStrXY
 lea    10(a7),a7

Stat2:
 move.w  Cf,d0
 cmp.w  #99,d0
 bhi 	Stat3
 lea strend(PC),a0
 moveq   #2,d1
 bsr ConvSTR
 move.w  #4,-(a7)
 move.l  a0,-(a7)
 move.w  #123,-(a7)
 move.w  #104,-(a7)
 jsr 	tios::DrawStrXY
 lea    10(a7),a7

Stat3:
 movem.l (a7)+,d0-d2/a0-a1
 rts

WriteChar:
 movem.l d0-d2/a0,-(a7)
 move.w  #$00FF,-(a7)
 clr.w	 -(a7)
 move.w  #$00FF,-(a7)
 move.w  #4,-(a7)
 move.w  d1,-(a7)
 move.w  d0,-(a7)
 move.w  d2,-(a7)
 jsr     tios::DrawCharXY
 lea	 14(a7),a7
 movem.l (a7)+,d0-d2/a0
 rts

GetLevelADR:
 movem.l d0/a0,-(a7)
 move.l  level_adr,a0
 clr.l   d0
 move.w  yn,d0
 mulu    #8,d0     ; Taille du grand niveau en Xn (0 -> MaxXn) => MaxXn+1
 add.w   xn,d0	   ; 0..7
 mulu    #240,d0   ; Et on multiplie par la taille d'un niveau : 15*8*2 Bytes
 add.l   d0,a0
 move.l  a0,level
 add.l   #15*8,a0  ; On ajoute un demi niveau !
 move.l  a0,leveltest
 movem.l (a7)+,d0/a0
 rts

FlashScreen:
 movem.l d0-d2/a0-a1,-(a7)
 moveq	 #19,d1
 move.l  #$FFFFFFFF,d2
RepInverseScr:
 move.w  #959,d0
 move.l	 #LCD_MEM,a0
 move.l  greyplane,a1
RepInv:
 eor.l  d2,(a0)+
 eor.l  d2,(a1)+
 dbra   d0,RepInv
 dbra   d1,RepInverseScr
 movem.l (a7)+,d0-d2/a0-a1
 rts

;**********************************************
;
;     Nouvelle interruption #1
;
;**********************************************

newint#1:
	tst.w timer		; Synchronise
	beq   NoDecTimer
	sub.w #1,timer
NoDecTimer:
	add.w #1,vbl_phase	; Wait_Vbl
	and.w #3,vbl_phase
	rte

oldint#1	dc.l 0
timer		dc.w 0
Speed		dc.w 8
vbl_phase	dc.w 0

; **********************
;
; 	FER DATAS
;
; ***********************

fernand  INCBIN fernand.bin	; Perso animation

xj:	dc.w 0
yj:	dc.w 0
xn	dc.w 0
yn	dc.w 0

xnd	dc.b 0
ynd 	dc.b 0
xd	dc.b 0
yd	dc.b 0

vith:	dc.w 1  ; Vitesse de dplacement =2^p1
Hauteur:
	dc.w 40 ; Hauteur d'un saut

Bj	dc.w 0
Cf	dc.w 0
Vi	dc.w 0

Diff	dc.w 30   ; Difficulte du jeu
Diff2	dc.w 300  ; 	"

;************************************
;
;		 Sprites datas
;
;************************************

NbrSprite	dc.w 0
ExNbrSprite	dc.w 0
MaxSprite	dc.w 8
sprite_handle	dc.w 0
sprite_adr	dc.l 0
sprite_back_store
		dc.l 0
SpriteAdrTemp	dc.l 0
Sprite		INCBIN 	sprite.bin

;***************************************
;
; 		Donnes du dcor
;
;***************************************

EffacerDecor	dc.w 0		; Nombre de 'dcor'  effacer
EffacerADR	dc.l 0,0,0,0,0  ; Adresse  l'cran (Max = 4)

decor    dc.l 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ; Le 'dcor' vide
 	 INCBIN decor.bin

;***************************************
;
; 		General stores
;
;***************************************

greyplane    dc.l 0

keystat      ds.b 10

;***************************************
;
;		LEVELS
;
;***************************************

; Taille du sous-niveau 15 en x et 8 en y
Name	dc.b "levelfr3",0
MainFolder	dc.b "main",0

level_adr	dc.l  0
level		dc.l  0
leveltest	dc.l  0

SubLevel	dc.w  0

;***************************************************
;
;                  Variables pour Dialog Box
;
;***************************************************
statut	dc.b "POWER :           LIFE:          KEYS:",0
str	ds.b  10
strend
TitleDialog dc.w 30,26,210,102,50,6
	dc.l _comment
 	dc.w 54,22
 	dc.l newgame
 	dc.W 10,62
	dc.l copyright
	dc.w 54,38
	dc.l option,0
OptDialog   dc.w 10,48,230,128
	dc.w 5,10
	dc.l difficulty
	dc.w 5,25
	dc.l speedchoice
	dc.w 15,40
	dc.l inputtxt
	dc.w 105,40
	dc.l Name
	dc.w 15,55
	dc.l hautbas
	dc.w 15,70
	dc.l waitvbl,0
inputdialog dc.w 54,46,186,82,16,6
	dc.l inputtxt,0
f5	dc.b "F5",0
f6	dc.b "F6",0
f7	dc.b "F7",0
f8	dc.b "F8",0
waitvbl	    dc.b " <- -> Wait_Vbl",0
hautbas	    dc.b 23," and ",24," => MaxSprite",0
inputtxt    dc.b "F8 Level :",0
difficulty  dc.b "F1 Easy F2 Normal F3 Hard",0
speedchoice dc.b "F5 Slow F6 Normal F7 Quick",0
newgame	    dc.b "F1 Play",0
option	    dc.b "F2 Option",0
copyright   dc.b "By  HD Developement",0
_comment   dc.b "Fernando 3",0


 end
